<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ServiceContract ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ServiceContract extends AbstractStructArrayBase
{
    /**
     * The Contract
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ServiceContract[]
     */
    public $Contract;
    /**
     * Constructor method for ArrayOfJP_ServiceContract
     * @uses ArrayOfJP_ServiceContract::setContract()
     * @param \StructType\JP_ServiceContract[] $contract
     */
    public function __construct(array $contract = array())
    {
        $this
            ->setContract($contract);
    }
    /**
     * Get Contract value
     * @return \StructType\JP_ServiceContract[]|null
     */
    public function getContract()
    {
        return $this->Contract;
    }
    /**
     * This method is responsible for validating the values passed to the setContract method
     * This method is willingly generated in order to preserve the one-line inline validation within the setContract method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateContractForArrayConstraintsFromSetContract(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_ServiceContractContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ServiceContractContractItem instanceof \StructType\JP_ServiceContract) {
                $invalidValues[] = is_object($arrayOfJP_ServiceContractContractItem) ? get_class($arrayOfJP_ServiceContractContractItem) : sprintf('%s(%s)', gettype($arrayOfJP_ServiceContractContractItem), var_export($arrayOfJP_ServiceContractContractItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Contract property can only contain items of type \StructType\JP_ServiceContract, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Contract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceContract[] $contract
     * @return \ArrayType\ArrayOfJP_ServiceContract
     */
    public function setContract(array $contract = array())
    {
        // validation for constraint: array
        if ('' !== ($contractArrayErrorMessage = self::validateContractForArrayConstraintsFromSetContract($contract))) {
            throw new \InvalidArgumentException($contractArrayErrorMessage, __LINE__);
        }
        $this->Contract = $contract;
        return $this;
    }
    /**
     * Add item to Contract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceContract $item
     * @return \ArrayType\ArrayOfJP_ServiceContract
     */
    public function addToContract(\StructType\JP_ServiceContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ServiceContract) {
            throw new \InvalidArgumentException(sprintf('The Contract property can only contain items of type \StructType\JP_ServiceContract, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Contract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ServiceContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ServiceContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ServiceContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ServiceContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ServiceContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Contract
     */
    public function getAttributeName()
    {
        return 'Contract';
    }
}
